<template>
  <div>
    <v-card>
      <div class="gris">
        <div>Modelo</div>
        <strong>{{ this.modelo.nombre_modelo }}</strong>
      </div>
      <!--   <v-card-title>
         <v-text-field
          v-model.trim="search"
          class="float-right pt-0 mt-0"
          clearable
          label="Buscar..."
          type="text"
          single-line
          hide-details
        >
          <template v-slot:append>
            <v-tooltip bottom>
              <template v-slot:activator="{ on }">
                <v-icon v-on="on">mdi-card-search-outline</v-icon>
              </template>
              Buscar
            </v-tooltip>
          </template>
        </v-text-field>
      </v-card-title>-->
      <v-data-table
        hide-default-header
        fixed-header
        disable-sort
        group-by="eje"
        hide-default-footer
        :items-per-page="100"
        :headers="headersNegocios"
        :items="rowsDisciplinas"
        :search="search"
        locale="es-MX"
        height="390"
        class="protocolos-disciplinas-summary"
      >
        <template v-slot:no-data>
          No se encuentran disciplinas
        </template>
        <template v-slot:header="{ props: { headers } }">
          <thead>
            <tr class="header">
              <th
                :class="[
                  { 'width-no': indexHeader === 0 },
                  { 'width-disciplina': indexHeader === 1 },
                  { 'text-center': indexHeader > 1 },
                  { 'text-negocios': indexHeader > 1 },
                  { 'width-negocios': indexHeader > 1 }
                ]"
                v-for="(header, indexHeader) in headers"
                :key="indexHeader"
              >
                <template v-if="indexHeader > 1 && header.item">
                  <v-avatar class="ma-0" size="80" tile>
                    <v-img
                      :contain="true"
                      :aspect-ratio="1"
                      position="center"
                      :src="header.item.src_logo"
                      :lazy-src="header.item.src_logo"
                      class="white--text align-end"
                      height="80"
                    >
                      <template v-slot:placeholder>
                        <v-row
                          class="fill-height ma-0"
                          align="center"
                          justify="center"
                        >
                          <v-progress-circular
                            indeterminate
                            color="grey lighten-5"
                          ></v-progress-circular>
                        </v-row>
                      </template>
                    </v-img>
                  </v-avatar>
                </template>
                <br />
                <strong>{{ header.text }}</strong>
                <div>
                  <template v-if="indexHeader === 0"
                    ><strong>No.</strong></template
                  >
                  <template v-if="indexHeader === 1">
                    <strong>Nombre de la disciplina</strong>
                  </template>
                  <template v-if="indexHeader > 1"
                    ><strong>Vincular medición</strong></template
                  >
                </div>
              </th>
            </tr>
          </thead>
        </template>
        <template
          v-for="(itemHeader, indexItemHeader) in headersNegocios"
          v-slot:[itemHeaderDynamicSlot(itemHeader.value)]="{ item }"
        >
          <template
            v-if="
              itemHeader.value === 'no' ||
                itemHeader.value === 'disciplina_name'
            "
          >
            {{ item[itemHeader.value] }}
          </template>
          <template v-else>
            <div :key="indexItemHeader + '-' + item.no">
              <div
                style="text-align:left"
                v-if="item[itemHeader.value].currentValue.length > 0"
              >
                <template
                  v-for="(item, index) in item[itemHeader.value].currentValue"
                >
                  <v-chip
                    :key="index"
                    label
                    small
                    color="grey lighten-2"
                    class="ma-1"
                  >
                    <span>{{
                      getProtocolosFromMetadata(item).descripcion
                    }}</span>
                  </v-chip>
                </template>
              </div>
              <div v-else>
                <span>No aplica</span>
              </div>
            </div>
          </template>
        </template>
        <template v-slot:group.header="{ group, groupBy, headers, items }">
          <th :colspan="headers.length">
            <center>
              <v-chip
                label
                small
                color="secondary lighten-4"
                text-color="white"
              >
                {{ serviceCommons.titleCase(group) }}
              </v-chip>
              <span class="grey--text">
                ->
              </span>
              <v-chip label small color="secondary lighten-4">
                <v-avatar size="10" left class="grey darken-1">
                  {{ items.length }}
                </v-avatar>
                Disciplinas
              </v-chip>
            </center>
          </th>
        </template>
      </v-data-table>
    </v-card>
  </div>
</template>
<style scoped>
.width-negocios {
  width: 200px;
  min-width: 200px;
}
.width-no {
  width: 100px;
  min-width: 50px;
}
.width-disciplina {
  width: auto;
  min-width: 300px;
}
.header th {
  height: 80px;
  padding: 0px;
}
</style>
<style>
.protocolos-disciplinas-summary.v-data-table div {
  max-height: 390px;
}
.protocolos-disciplinas-summary.v-data-table table {
  background: whitesmoke;
}
.protocolos-disciplinas-summary.v-data-table
  tbody
  tr:hover:not(.v-data-table__expanded__content):not(.v-row-group__header) {
  background: none;
}
.protocolos-disciplinas-summary.v-data-table
  tbody
  tr:not(:last-child)
  td:not(.v-data-table__mobile-row):not(.v-row-group__header) {
  border-bottom: 1px dashed #9e9e9e;
}
.protocolos-disciplinas-summary.v-data-table tbody tr td {
  height: 90px !important;
  vertical-align: middle !important;
}
</style>
<script>
import store from "@/store";
import { required, requiredIf } from "vuelidate/lib/validators";
const serviceCommons = store.state.serviceCommons;
const serviceLocalStorage = store.state.serviceLocalStorage;
const urlServicesPlataformaFranquicia =
  store.state.urlServicesPlataformaFranquicia;
const defaultHeaders = [
  {
    text: "",
    value: "no",
    item: null,
    align: "left",
    index: -3
  },
  {
    text: "",
    value: "disciplina_name",
    item: null,
    align: "left",
    index: -2
  },
  {
    text: "Eje",
    value: "eje",
    item: null,
    align: "left",
    index: -1
  }
];
function merge(a, b, prop) {
  var reduced = a.filter(function(aitem) {
    return !b.find(function(bitem) {
      return aitem[prop] === bitem[prop];
    });
  });
  return reduced.concat(b);
}
export default {
  name: "Component-SummaryDisciplinasNegocioModelo",
  props: ["data"],
  data() {
    return {
      access_token: serviceLocalStorage.getAccessToken(),
      search: ""
    };
  },
  computed: {
    metadata() {
      if (!this.data.metadata) {
        return {};
      }
      return this.data.metadata;
    },
    modelo() {
      if (!this.data.modelo) {
        return {};
      }
      return this.data.modelo;
    },
    serviceCommons() {
      return serviceCommons;
    },
    headersNegocios() {
      let headers = JSON.parse(JSON.stringify(defaultHeaders));
      if (this.modelo.negocios_modelo) {
        this.modelo.negocios_modelo.forEach(
          (itemNegocioModelo, indexItemNegocioModelo) => {
            let negocio = this.getNegocioFromMetadata(
              itemNegocioModelo.id_negocio
            );
            let header = {
              text: negocio.descripcion,
              value: "header_" + indexItemNegocioModelo,
              item: negocio,
              align: "center",
              index: indexItemNegocioModelo
            };
            headers.push(header);
          }
        );
      }
      return headers;
    },
    rowsDisciplinas() {
      let rows = [];
      if (this.modelo.ejes_modelo) {
        let no = 0;
        this.modelo.ejes_modelo.forEach((itemEjeModelo, indexItemEjeModelo) => {
          if (!itemEjeModelo.deleted) {
            let eje = this.getEjeFromMetadata(itemEjeModelo.id_eje);
            if (itemEjeModelo.disciplinas_eje) {
              itemEjeModelo.disciplinas_eje.forEach(
                (itemDisciplinaEje, indexItemDisciplinaEje) => {
                  no++;
                  if (!itemDisciplinaEje.deleted) {
                    let disciplina = this.getDisciplinaFromMetadata(
                      itemDisciplinaEje.id_disciplina
                    );
                    let row = {
                      no: no,
                      disciplina_name: disciplina.descripcion,
                      eje: eje.descripcion
                    };
                    if (this.modelo.negocios_modelo) {
                      this.modelo.negocios_modelo.forEach(
                        (itemNegocioModelo, indexItemNegocioModelo) => {
                          let positions = {
                            indexPlain: no - 1,
                            indexNegocioModelo: indexItemNegocioModelo,
                            indexEjeModelo: indexItemEjeModelo,
                            indexDisciplinaEje: indexItemDisciplinaEje
                          };
                          const disciplinasEjeNegocio = this.data.modelo
                            .negocios_modelo[positions.indexNegocioModelo]
                            .ejes_modelo[positions.indexEjeModelo]
                            .disciplinas_eje_negocio;
                          const disciplinaProtocolo =
                            disciplinasEjeNegocio[positions.indexDisciplinaEje];
                          if (disciplinaProtocolo) {
                            const currentValue = disciplinaProtocolo.protocolos;
                            const currentProtocolos = [];
                            currentValue.forEach((itemProtocoloDisciplina) => {
                              if (!itemProtocoloDisciplina.deleted) {
                                currentProtocolos.push(
                                  itemProtocoloDisciplina.id_protocolo
                                );
                              }
                            });
                            let originalItem = {
                              positions,
                              currentValue: currentProtocolos
                            };
                            row[
                              "header_" + indexItemNegocioModelo
                            ] = originalItem;
                          }
                        }
                      );
                    }
                    rows.push(row);
                  }
                }
              );
            }
          }
        });
      }
      return rows;
    }
  },
  methods: {
    itemHeaderDynamicSlot(key) {
      return `item.${key}`;
    },
    getDisciplinaFromMetadata(id_disciplina) {
      if (this.metadata.disciplinas) {
        let disciplina_filtered = this.metadata.disciplinas.filter(
          (itemDisciplina) => itemDisciplina.id_disciplina === id_disciplina
        )[0];
        if (disciplina_filtered) {
          return disciplina_filtered;
        }
        return {};
      }
      return {};
    },
    getEjeFromMetadata(id_eje) {
      if (this.metadata.ejes) {
        let eje_filtered = this.metadata.ejes.filter(
          (itemEje) => itemEje.id_eje === id_eje
        )[0];
        if (eje_filtered) {
          return eje_filtered;
        }
        return {};
      }
      return {};
    },
    getNegocioFromMetadata(id_negocio) {
      if (this.metadata.negocios) {
        let negocio_filtered = this.metadata.negocios.filter((itemNegocio) => {
          const src_logo =
            urlServicesPlataformaFranquicia +
            "/file/secure/read/" +
            this.serviceCommons.stringToBase64(itemNegocio.path_logo) +
            "?access_token=" +
            this.access_token;
          itemNegocio.src_logo = src_logo;
          return itemNegocio.id_negocio === id_negocio;
        })[0];
        if (negocio_filtered) {
          return negocio_filtered;
        }
        return {};
      }
      return {};
    },
    getProtocolosFromMetadata(id_protocolo) {
      if (this.metadata.protocolos) {
        let protocolos_filtered = this.metadata.protocolos.filter(
          (itemProtocolo) => itemProtocolo.id_protocolo === id_protocolo
        )[0];
        if (protocolos_filtered) {
          return protocolos_filtered;
        }
        return {};
      } else {
        return {};
      }
    }
  }
};
</script>
